-------------------------------------------------------------------------------------
-- | Namespace Definitions |---------------------------------------------------------
-------------------------------------------------------------------------------------

-- Retrieve the addon name and the namespace table.
local addon, npcg = ...

local functua = npcg.functua
local stringLib = npcg.functua.string
local util = npcg.functua.util

function isFirstGlanceWellDefined(characterTemplate)
  return
    characterTemplate:getName()    ~= "" and
    characterTemplate:getAge()     ~= "" and
    characterTemplate:getRace()    ~= "" and
    characterTemplate:getClass()   ~= "" and
    characterTemplate:getFeature() ~= ""
end

local characterStrings = { }
table.insert(
  characterStrings,
  function(characterTemplate)
    return functua.list.foldr(
      stringLib.combineWithSpace,
      "",
      {
        "||",
        stringLib.ucWords(characterTemplate:getName()),
        "is",
        stringLib.aOrAn(characterTemplate:getAge()),
        characterTemplate:getAge(),
        stringLib.ucWords(characterTemplate:getTribe()),
        stringLib.ucWords(characterTemplate:getRace()),
        characterTemplate:getGender(),
        "that appears to be",
        stringLib.aOrAn(characterTemplate:getClass()),
        characterTemplate:getClass(),
        "and",
        stringLib.lcFirst(characterTemplate:getFeature()) .. "."
      } )
  end
)

table.insert(
  characterStrings,
  function(characterTemplate)
    return functua.list.foldr(
      stringLib.combineWithSpace,
      "",
      {
        "|| Behold! It is",
        stringLib.ucWords(characterTemplate:getName()) .. "!",
        stringLib.ucFirst(stringLib.xhe(characterTemplate:getGender(), "%xhe")),
        "is",
        stringLib.aOrAn(characterTemplate:getTribe()),
        characterTemplate:getTribe(),
        characterTemplate:getRace() .. ".",
        stringLib.ucFirst(stringLib.xhe(characterTemplate:getGender(), "%xhe")),
        "seems to work as",
        stringLib.aOrAn(characterTemplate:getClass()),
        characterTemplate:getClass().. ",",
        "is",
        characterTemplate:getAge(),
        "and to top it all off,",
        stringLib.xhe(characterTemplate:getGender(), "%xhe"),
        stringLib.lcFirst(characterTemplate:getFeature()) .. "."
      } )
  end
)

-- generatesCharacterString :: (Name a, Age a, Tribe a, Race a, Gender a, Class a, Feature a) => a -> string
function generateCharacterString(characterTemplate)
	return
    util.eitherOr(
      isFirstGlanceWellDefined(characterTemplate),
      npcg.processSubstitutionString(characterTemplate, util.randomFrom(characterStrings)(characterTemplate)),
      "")
end



-- End of File.